// Triangle mesh viewer + corner table + subdivision + smoothing
// Written by Jarek Rossignac June 2006. Modified Septmber 2007
import processing.opengl.*;                // load OpenGL
int w=6;                                   // size of initial Tmesh-grid made in setup
int nv = w*w, maxnv = 20000;               // current and max number of vertices

// ** SETUP **
void setup() { 
  size(800, 800, OPENGL);  
  setColors(); 
  sphereDetail(6); //smooth();
  PFont font = loadFont("Courier-14.vlw"); textFont(font, 12);  // font for writing labels on screen
  fn[0]="flat.vts"; fn[1]="bunny.vts"; fn[2]="horse.vts"; fn[3]="torus.vts";  fn[4]="tet.vts"; 
  fn[5]="fandisk.vts"; fn[6]="squirrel.vts"; fn[7]="venus.vts";
  for (int i=0; i<maxnv; i++) {G[i]=new pt(0,0,0); Nv[i]=new vec(0,0,0);};   // init vertices and normals
  for (int i=0; i<maxnt; i++) {Nt[i]=new vec(0,0,0);  skeleton[i]=0; };       // init triangler normals
  for (int i=0; i<w; i++) {for (int j=0; j<w; j++) {                          // make a 2D grid of vertices
    G[w*i+j].setTo(height*.8*j/(w-1)+height/10,height*.8*i/(w-1)+height/10,0);}}    
  for (int i=0; i<w-1; i++) {for (int j=0; j<w-1; j++) {                  // define the triangles for the grid
      V[(i*(w-1)+j)*6]=i*w+j;       V[(i*(w-1)+j)*6+2]=(i+1)*w+j;       V[(i*(w-1)+j)*6+1]=(i+1)*w+j+1;
      V[(i*(w-1)+j)*6+3]=i*w+j;     V[(i*(w-1)+j)*6+5]=(i+1)*w+j+1;     V[(i*(w-1)+j)*6+4]=i*w+j+1;}; };
  initMesh();
  initView();  
  loadButtons(); loadToggles();     // menus
  this.addMouseWheelListener(new CMouseWheelEvent());// wheel
  } 

 
// ** DRAW **
void draw() {
  background(white); 
  perspective(PI/2.0,width/height,1.0,6.0*Rbox); 
  if (showHelpText) {camera(); translate(-290,-290,0); scale(1.7,1.7,1.0); showHelp(); showColors();  return; };
  lights(); directionalLight(0,0,128,0,1,0); directionalLight(0,0,128,0,0,1);
  sphereDetail(4); 
  translate(float(height)/2, float(height)/2, 0.0);     // center view wrt window  
  if ((!keyPressed)&&(mousePressed)) {C.pan(); C.pullE(); };
  if ((keyPressed)&&(mousePressed)) {updateView();}; 
  C1.track(C); C2.track(C1);   C2.apply();                             
  renderMesh();
  // menu();
  }

//***      KEY ACTIONS
void keyPressed() { keys(); };
void mousePressed() {C.anchor(); C.pose();  };       // record where the cursor was when the mouse was pressed
void mouseReleased() {C.anchor(); C.pose(); };  // reset the view if any key was pressed when mouse was released 









