//**********************************
//***      corners tools
// Written by Jarek Rossignac,  June 2006 
//**********************************
     
     
void left() {if(l(c)!=-1) {c=l(c);};};
void right() {if(r(c)!=-1) {c=r(c);};};
void back() {if(o(c)!=-1) {c=o(c);};};

int t (int c) {int r=int(c/3); return(r);};
int n (int c) {int r=3*int(c/3)+(c+1)%3; return(r);};
int p (int c) {int r=3*int(c/3)+(c+2)%3; return(r);};
int v (int c) {return(V[c]);};
int o (int c) {return(O[c]);};
int l (int c) {return(o(n(c)));};
int r (int c) {return(o(p(c)));};
int w (int c) {return(W[c]);};               // temporary indices to mid-edge vertices associated with corners during subdivision
boolean border (int c) {return((O[c]==-1)||(nb(c)&&(skeleton[t(c)]!=skeleton[t(o(c))])));};  // returns true if corner has no opposite
boolean nb(int c) {return(O[c]!=-1);};
pt g (int c) {return(G[V[c]]);};             // shortcut to get the point of the vertex v(c) of corner c

void writeCorner (int c) {
  println("c="+c+", n="+n(c)+", p="+p(c)+", o="+o(c)+", v="+v(c)+", t="+t(c)+", EdgeBreaker symbol="+triangleSymbol[t(c)]+".");
  }; 


pt cg(int c) {pt cPt = midPt(g(c),midPt(g(c),triCenter(t(c))));  return(cPt); };   // computes point at corner
void showCorner(int c, int r) {pt cPt = midPt(g(c),midPt(g(c),triCenter(t(c))));  cPt.show(r); };   // renders corner c as small ball
void showCornerAndNormal(int c, int r) {pt cPt = midPt(g(c),midPt(g(c),triCenter(t(c))));  noStroke(); cPt.show(r); 
                     stroke(magenta); vec N = Nt[t(c)].make(); N.makeUnit();  N.mul(10*r);  N.show(cPt);};   // renders corner c as small ball

void drawEdge(int c) {line(g(p(c)).x,g(p(c)).y,g(p(c)).z,g(n(c)).x,g(n(c)).y,g(n(c)).z); };  // draws edge of t(c) opposite to corner c

void computeOnaive() {                         // sets the O table from the V table, assumes consistent orientation of triangles
  for (int i=0; i<3*nt; i++) {O[i]=-1;};  // init O table to -1: has no opposite (i.e. is a border corner)
  for (int i=0; i<3*nt; i++) {  for (int j=i+1; j<3*nt; j++) {       // for each corner i, for each other corner j
      if( (v(n(i))==v(p(j))) && (v(p(i))==v(n(j))) ) {O[i]=j; O[j]=i;};};}; // make i and j opposite if they match         
  };

void computeO() { 
  int nIC [] = new int [maxnv];                   // number of incident corners
//  println("COMPUTE O: nv="+nv +", nt="+nt +", nc="+nc );
  int maxValence=0;
  for (int c=0; c<nc; c++) {O[c]=-1;};  // init O table to -1: has no opposite (i.e. is a border corner)
  for (int v=0; v<nv; v++) {nIC[v]=0; };
  for (int c=0; c<nc; c++) {nIC[v(c)]++;}
  for (int v=0; v<nv; v++) {if(nIC[v]>maxValence) {maxValence=nIC[v]; };};
  println(" Max valence = "+maxValence+". ");
  int IC [][] = new int [maxnv][maxValence];                   // incident corners
  for (int v=0; v<nv; v++) {nIC[v]=0; };
  for (int c=0; c<nc; c++) {IC[v(c)][nIC[v(c)]++]=c;}
  for (int c=0; c<nc; c++) {
    for (int i=0; i<nIC[v(p(c))]; i++) {
      int a = IC[v(p(c))][i];
      for (int j=0; j<nIC[v(n(c))]; j++) {
         int b = IC[v(n(c))][j];
         if ((b==n(a))&&(c!=n(b))) {O[c]=n(b); O[n(b)]=c; };
         };
      };
    };
  }


//********
void excludeInvisibleTriangles () {for (int b=0; b<nc; b++) {if (!visible[t(o(b))]) {O[b]=-1;};};}

void fanHoles() {
  println("FANHOLES: nv="+nv +", nt="+nt +", nc="+nc );
  for (int t=0; t<nt; t++) {Island[t]=1;}; nIslands=1;
  for (int t=0; t<nt; t++) {VisitedT[t]=false;};
  int lnt=nt;
  int L=0;
  for (int cc=0; cc<nc; cc++) {
   if (visible[t(cc)]&&(!VisitedT[t(cc)]) && (!nb(cc) )) {L++;
      print("<"); G[nv].setTo(0,0,0); int hl=fanHole(cc,L); G[nv].mul(1.0/float(hl)); nv++; println("> hl="+hl);
     };
   };
   for (int t=lnt; t<nt; t++) {visible[t]=true;};
   nc=3*nt;
   println("Filled "+L+" holes");
  }
  
int fanHole(int cc, int L) {
 int hl=0; int o=0;  int f=cc;
 print("."); VisitedT[t(f)]=true; hl++; Land[nt]=false; Lake[nt]=L; o=3*nt; V[o]=nv; V[n(o)]=v(p(f)); V[p(o)]=v(n(f)); O[o]=f; O[f]=o; nt++; G[nv].addPt(g(p(f)));
 int lc=p(o); 
 f=n(f);  while(nb(f)) {f=n(o(f)); }; 
 while (f!=cc) {    
       print("."); VisitedT[t(f)]=true; hl++; Land[nt]=false; Lake[nt]=L; o=3*nt; V[o]=nv; V[n(o)]=v(p(f)); V[p(o)]=v(n(f)); O[o]=f; O[f]=o; nt++; G[nv].addPt(g(p(f)));
      O[n(o)]=lc; O[lc]=n(o); lc=p(o);
      f=n(f);  while(nb(f)&&(f!=cc)) {f=n(o(f)); }; 
      }; 
  O[lc]=n(o(cc)); O[n(o(cc))]=lc; c=lc;
  return(hl);
  }
  
void compactVO() {  
  println("COMPACT TRIANGLES: nv="+nv +", nt="+nt +", nc="+nc );
  int[] U = new int [nc];
  int lc=-1; for (int c=0; c<nc; c++) {if (visible[t(c)]) {U[c]=++lc; }; };
//  println("original"); for (int c=0; c<nc; c++) {println("T["+c+"]="+t(c)+", visible="+visible[t(c)]+", v="+v(c)+",  o="+o(c)+",  U="+U[c]);};
  for (int c=0; c<nc; c++) {if (nb(c)) {O[c]=U[o(c)];} else {O[c]=-1;}; };
//  println("reset O"); for (int c=0; c<nc; c++) {println("T["+c+"]="+t(c)+", visible="+visible[t(c)]+", v="+v(c)+",  o="+o(c)+",  U="+U[c]);};
  int lt=0;
  for (int t=0; t<nt; t++) {
    if (visible[t]) {
      V[3*lt]=V[3*t]; V[3*lt+1]=V[3*t+1]; V[3*lt+2]=V[3*t+2]; 
      O[3*lt]=O[3*t]; O[3*lt+1]=O[3*t+1]; O[3*lt+2]=O[3*t+2]; 
      Lake[lt]=Lake[t];
      Land[lt]=Land[t];
      visible[lt]=true; 
      lt++;
      };
    };
// println("nt="+nt+", lt="+lt); nt=lt; nc=3*nt;
// println("compacted V and O"); for (int c=0; c<nc; c++) {println("T["+c+"]="+t(c)+", visible="+visible[t(c)]+", v="+v(c)+",  o="+o(c)+",  U="+U[c]);};
 println("      ...  NOW: nv="+nv +", nt="+nt +", nc="+nc );
  }

void compactV() {  
  println("COMPACT VERTICES: nv="+nv +", nt="+nt +", nc="+nc );
  int[] U = new int [nv];
  boolean[] deleted = new boolean [nv];
  for (int v=0; v<nv; v++) {deleted[v]=true;};
  for (int c=0; c<nc; c++) {deleted[v(c)]=false;};
  int lv=-1; for (int v=0; v<nv; v++) {if (!deleted[v]) {U[v]=++lv; }; };
//  println("original"); for (int v=0; v<nv; v++) {print("deleted["+v+"]="+deleted[v]); G[v].write();};
  for (int c=0; c<nc; c++) {V[c]=U[v(c)]; };
//  println("reset V"); for (int v=0; v<nv; v++) {print("deleted["+v+"]="+deleted[v]); G[v].write();};
  lv=0;
  for (int v=0; v<nv; v++) {
    if (!deleted[v]) {G[lv].setToPoint(G[v]);  deleted[lv]=false; 
      lv++;
      };
    };
 nv=lv;
// println("reset V"); for (int v=0; v<nv; v++) {print("deleted["+v+"]="+deleted[v]); G[v].write();};
 println("      ...  NOW: nv="+nv +", nt="+nt +", nc="+nc );
  }

void fanLakes() {
  for (int t=0; t<nt; t++) {if (Land[t]) {visible[t]=true;} else {visible[t]=false;}; };
  };  
