boolean showHelpText=true;
  void showHelp() {
    fill(yellow,50); rect(0,0,height,height); pushMatrix(); translate(20,20); fill(0);
        text("                    CURVE EDITOR written by Jarek Rossignac in March 2007",0,0); translate(0,20);
       translate(0,20);
        text("Click in this window. Press SPACE to show/hide this help text  ",0,0); translate(0,20);
        text("CORNER OPS: 'c' pick, 'p','n','o','l','r','t'   ",0,0); translate(0,20);
        text("TRIANGLE OPS: 'f' flip edge, 'm' merge vertices', 'k' hide/rveal triangle  ",0,0); translate(0,20);
        text("MESH OPS: 'R' refine, 'S' smooth, 'M' mnimize, 'F' fill holes  ",0,0); translate(0,20);
        text("EDGEBREAKER: 'i' init, 'a' advance, 'b' compress, 'B' show colors   ",0,0); translate(0,20);
        text("DISTANCE: 'D' show, 'I' isolation, 'P' path, 'd' distance, ',' smaller, '.' larger, '0' zero   ",0,0); translate(0,20);
        text("FILES: 'g' next file. 'G' read from file, 'A' archive.",0,0); translate(0,20);
        text("VIEW: 'z' zoom, 'H home, 'j' jump, 'J' jumping,   ",0,0); translate(0,20);
        text("DISPLAY: 'E' edges, 'V' vertices, 'N' normals, ",0,0); translate(0,20);
        text("   ",0,0); translate(0,20);
        text("If running local: 'W' to save points and 'X' to save a picture (DO NOT USE IN WEB BROWSER!).",0,0); translate(0,20);
 
     popMatrix(); noFill();
        }
  void keys() {
  if (key==' ') {showHelpText=!showHelpText;};
  if (key==',') {maxr--; if (maxr<1) maxr=1; computeDistance(maxr);};
  if (key=='.') {maxr++; computeDistance(maxr);};
  if (key=='0') {maxr=0; computeDistance(maxr);};
  if (key=='a') {EBmove();};   
  if (key=='b') {firstCorner=c; EBcompress(firstCorner);};   
  if (key=='c') {C.setMark(); hitTriangle();/* C.F.setToPoint(mark); C.pullE(); C.pose(); */ writeCorner(c); };  
  if (key=='d') {computeDistance(maxr);}; 
  if (key=='f') {flip(c);}; 
  if (key=='g') {fni=(fni+1)%fniMax; println("Will read model "+fn[fni]);};
  if (key=='i') {EBinit();};   
  if (key=='j') {if (showEBrec) {EBjump();} C.jump(c); C.snapD(); C.pullE();}
  if (key=='k') {C.setMark(); hitTriangle();  visible[t(c)]=!visible[t(c)]; };  
  if (key=='l') {println("l("+c+")="+l(c)); if(l(c)!=-1) {c=l(c);}; if (jumps) {C.jump(c);};};
  if (key=='m') {collapse(c); c=l(c);};   
  if (key=='n') {println("n("+c+")="+n(c)); c=n(c);};  
  if (key=='o') {println("o("+c+")="+o(c)); if(o(c)!=-1) {c=o(c);}; if (jumps) {C.jump(c);}; };  
  if (key=='p') {println("p("+c+")="+p(c)); c=p(c);};  
  if (key=='r') {println("r("+c+")="+r(c)); if(r(c)!=-1) {c=r(c);}; if (jumps) {C.jump(c);};}; 
  if (key=='t') {println("t("+c+")="+t(c)+" symbol = "+triangleSymbol[t(c)]+" out of "+nt+" triangles");};  

  if (key=='A') {saveMesh(); };  
  if (key=='B') {showEB=!showEB;}; 
  if (key=='D') {showDistance=!showDistance;}; 
  if (key=='E') {showEdges=!showEdges; };  
  if (key=='F') { excludeInvisibleTriangles(); fanHoles(); compactVO(); compactV();  println("...DONE filling holes");  }; 
  if (key=='G') {loadMesh(); print("Loaded. "); initMesh(); println("Initialized. "); initView(); step=0; };  
  if (key=='H') {C.F.setToPoint(Cbox); C.D=Rbox*2; C.U.setTo(0,1,0); C.E.setToPoint(C.F); C.E.addVec(new vec(0,0,1)); C.pullE(); C.pose();};
  if (key=='I') {computeIsolation(); }; 
  if (key=='J') {jumps=!jumps; }; 
  if (key=='M') {doFlips();}; 
  if (key=='N') {showNormals=!showNormals; };  
  if (key=='P') if (showPath) {showPath=false;} else {computePath(); showPath=true;};
  if (key=='R') {print("Subdividing..."); splitEdges(); bulge(); splitTriangles(); initMesh(); println("done");};   // refine mesh
  if (key=='S') {computeLaplaceVectors(); tuck(0.6); computeLaplaceVectors(); tuck(-0.6); };  
  if (key=='V') {showVertices=!showVertices; };  
  if (key=='X') {String S="mesh"+"-####.tif"; saveFrame(S);};   ;

  if (keyCode==LEFT) {left(); right(); left(); if (jumps) {C.jump(c);};};
  if (keyCode==RIGHT) {right(); left(); right(); if (jumps) {C.jump(c);};};
  if (keyCode==DOWN) {back();left(); right(); right(); left();back(); if (jumps) {C.jump(c);}; };
  if (keyCode==UP) {left(); right(); right(); left(); if (jumps) {C.jump(c);};};


//  if (key=='d') {int lcs=leadingCS(); println("Found "+lcs+" leading Cs"); EBstats(lcs);};
//  if (key=='s') {showEBrec=!showEBrec; };
//  if (key=='u') {C.U.setToVec(Nt[t(c)]); C.U.back();};  
//  if (key=='w') {println(); print("clers= "); symbols=0; EBprintS(firstCorner); println(" .");};   
//  if (key=='x') {  };
//  if (key=='+') {lake=(lake)%nLakes+1;   println("lake="+lake); maxTic=0;};
//  if (key=='-') {lake=(lake+nLakes-2)%nLakes+1;   println("lake="+lake); maxTic=0;};


//  if (key=='B') {print("Building..."); findLakes(); println("done");}; //build Skeleton and lakes

//  if (key=='C') {println("Land="+Land[t(c)]+", Island="+Island[t(c)]+", Lake="+Lake[t(c)]+", Distance="+Distance[t(c)]); }; 
//  if (key=='F') {flattenLake(); }; 
  
//  if (key=='I') {showClusters=!showClusters;}; 
//  if (key=='L') {showSelectedLake=!showSelectedLake;};  
//  if (key=='M') {for (int i=1; i<451; i++) {EBmove();};   };
//  if (key=='O') {computeO();};  
//  if (key=='P') {showOtherLakes=!showOtherLakes;};  

//  if (key=='S') {showSkeleton=!showSkeleton;};  // compute skeleton
  if (key=='T') {if (showTriangles&&showSelectedTriangle) {showTriangles=false; showSelectedTriangle=false;} else {
                   if (!showTriangles&&showSelectedTriangle) {showTriangles=true; showSelectedTriangle=true;};
                   if (showTriangles&&!showSelectedTriangle) {showTriangles=false; showSelectedTriangle=true;};
                   if (!showTriangles&&!showSelectedTriangle) {showTriangles=true; showSelectedTriangle=false;};
                        }; 
                 };  
  if (key=='U') { };  
//  if (key=='W') {traceLakeBorder(lake);};  p
//  if (key=='Z') {   };  // bi-laplace smoothing
  }
  
  
void updateView() {
  if (keyCode==SHIFT) {C.Pan(); C.pullE(); };
  if (keyCode==CONTROL) {C.turn(); C.pullE(); };  
  if (key=='z') {C.pose(); C.zoom(); C.pullE(); };
   if (key=='1') {C.pose(); C.fly(1.0); C.pullE(); };  
   if (key=='2') {C.pose(); C.Pan(); C.pullE(); };
   if (key=='3') {C.pose(); C.fly(-1.0); C.pullE();  };
   if (key=='4') {C.pose(); C.Turn(); C.pullE(); };
   if (key=='5') {C.pan(); C.pullE(); }; 
  }
  /*

flipOrientation=!flipOrientation; print("Will "); if(flipOrientation) {print("not ");}; println("orientation");

 

computeO();
 

println(nv+" vertices:"); for (int i=0; i<nv; i++) { print("V"+i+" = "); G[i].write();}; println(nt+" triangles:"); for (int i=0; i<nt; i++) { writeTri(i);}; 
print("Refining..."); splitEdges(); splitTriangles(); computeO(); computeValence(); computeTriNormals(); println("done");
*/
