//**********************************
//***   tools for rendering T-meshes
// Written by Jarek Rossignac,  June 2006 
//**********************************
void initMesh() { 
   for (int i=0; i<maxnt; i++) {Nt[i]=new vec(0,0,0); visible[i]=true; skeleton[i]=0;};  
   computeO(); 
   computeValenceAndResetNormals(); 
   computeTriNormals(); 
   computeVertexNormals(); 
   c=0;   
  }

void shade(int i) {if(visible[i]) { beginShape(TRIANGLES); G[V[3*i]].vert(); G[V[3*i+1]].vert(); G[V[3*i+2]].vert(); endShape(); };}; // shade tris

void showBorder() {for (int i=0; i<nc; i++) {if (visible[t(i)]&&border(i)) {drawEdge(i);}; }; };         // draws all border edges
 
pt triCenter(int i) {return(triCenterFromPts( G[V[3*i]], G[V[3*i+1]], G[V[3*i+2]] )); };  // computes center of triangle t(i) 

vec triNormal(int i) { return(triNormalFromPts(G[V[3*i]], G[V[3*i+1]], G[V[3*i+2]])); };  // computes triangle t(i) normal * area / 2

void computeTriNormals() {for (int i=0; i<nt; i++) {Nt[i].setToVec(triNormal(i)); }; };             // caches normals of all tirangles

void computeVertexNormals() {  // computes the vertex normals as sums of the normal vectors of incident tirangles scaled by area/2
  for (int i=0; i<nv; i++) {Nv[i].setTo(0,0,0);};  // resets the valences to 0
  for (int i=0; i<3*nt; i++) {Nv[v(i)].add(Nt[t(i)]);};
  for (int i=0; i<nv; i++) {Nv[i].makeUnit();}; 
  };

void showTriNormals() {vec N= new vec(0,0,0);                                             // renders tirangle normals with length 20
  for (int i=0; i<nt; i++) { N.setToVec(Nt[i]); N.makeUnit();  N.mul(5*r);  N.show(triCenter(i)); };
   };

void showVertexNormals() {vec N= new vec(0,0,0);                                             // renders tirangle normals with length 20
  for (int i=0; i<nv; i++) {N.setToVec(Nv[i]); N.makeUnit(); N.mul(5*r);  N.show(G[i]); };
  };

void writeTri (int i) {
  println("T"+i+": V = ("+V[3*i]+":"+v(o(3*i))+","+V[3*i+1]+":"+v(o(3*i+1))+","+V[3*i+2]+":"+v(o(3*i+2))+")"); };

void computeBox() {
  pt Lbox =  G[0].make();  pt Hbox =  G[0].make();
  for (int i=1; i<nv; i++) { 
    Lbox.x=min(Lbox.x,G[i].x); Lbox.y=min(Lbox.y,G[i].y); Lbox.z=min(Lbox.z,G[i].z);
    Hbox.x=max(Hbox.x,G[i].x); Hbox.y=max(Hbox.y,G[i].y); Hbox.z=max(Hbox.z,G[i].z); 
    };
  Cbox.setToPoint(midPt(Lbox,Hbox));  Rbox=Cbox.disTo(Hbox);
//  println("Box r="+Rbox); print("C="); Cbox.write(); print("L="); Lbox.write(); print("H="); Hbox.write();
  };

void hitTriangle() {
  float smallestDepth=10000000;
  boolean hit=false;
  for (int t=0; t<nt; t++) {
    if (rayHitTri(eye,mark,g(3*t),g(3*t+1),g(3*t+2))) {hit=true;
      float depth = rayDistTriPlane(eye,mark,g(3*t),g(3*t+1),g(3*t+2));
      if ((depth>0)&&(depth<smallestDepth)) {smallestDepth=depth;  c=3*t;};
      }; 
    };
  if (hit) {
    pt X = eye.make(); X.addScaledVec(smallestDepth,eye.vecTo(mark));
    mark.setToPoint(X);
    float distance=X.disTo(g(c));
    int b=c;
    if (X.disTo(g(n(c)))<distance) {b=n(c); distance=X.disTo(g(b)); };
    if (X.disTo(g(p(c)))<distance) {b=p(c);};
    c=b;
    };
  }

void renderMesh() {
  int col=60;
  noSmooth(); noStroke();
   if(showDistance) for(int t=0; t<nt; t++) {fill(60,120,(rings-Mt[t])*120/rings); shade(t);};  
   if(showEB&&!showDistance) {
      for(int t=0; t<nt; t++) {fill(cyan);
         if (triangleSymbol[t]=='w') {fill(white);};
         if (triangleSymbol[t]=='B') {fill(black);};
         if (triangleSymbol[t]=='C') {fill(yellow);};
         if (triangleSymbol[t]=='L') {fill(blue);};
         if (triangleSymbol[t]=='E') {fill(magenta);};
         if (triangleSymbol[t]=='R') {fill(orange);};
         if (triangleSymbol[t]=='S') {fill(red);};
         shade(t); 
         }
      };  
    if(!showEB&&!showDistance) {fill(cyan); for(int t=0; t<nt; t++)  shade(t); };  
  smooth();
  if (showEdges) {stroke(red); for(int i=0; i<nc; i++) if(visible[t(i)]) drawEdge(i);};  
  stroke(blue); showBorder();
  if (showVertices) {noStroke(); noSmooth();
    for (int v=0; v<nv; v++) {if (Tv[v]==0) fill(blue); if (Tv[v]==1) fill(red); if (Tv[v]==2) fill(green); G[v].show(r); };
    };
  if (showLabels) { fill(black); for (int i=0; i<nv; i++) {G[i].label(str(i),labelD); }; };
  if (showNormals) {stroke(blue); showTriNormals(); stroke(magenta); showVertexNormals(); };                // show triangle normals
  if (showSelectedTriangle) {
    noStroke(); fill(green); shade(t(c)); 
    fill(blue); stroke(dblue); showCornerAndNormal(c,r);  
    }; 
  fill(dred); mark.show(r); // stroke(red); line(eye.x,eye.y,eye.z,mark.x,mark.y,mark.z);
  }
